package com.jpsoft.picc.test;

import com.jpsoft.picc.modules.common.constant.PolicyStatus;
import lombok.Data;
import org.junit.Test;

import java.util.Optional;
import java.util.function.Consumer;
import java.util.function.Function;

public class NewApiTest {
    @Data
    private class Subject{
        private Integer score;
    }

    @Data
    private class Student{
        private Subject subject;
    }

    @Test
    public void testFunction(){
        Function<Integer,Integer> func1 = i->i+2;
        Function<Integer,Integer> func2 = i->i*3;

        Consumer c = System.out::println;

        c.accept(func2.andThen(func1).apply(2));
    }

    @Test
    public void testOptional(){
        Student student = new Student();
        Subject subject = new Subject();
        subject.setScore(100);

        student.setSubject(subject);

        Integer score = Optional.ofNullable(student)
                        .map(Student::getSubject)
                        .map(Subject::getScore)
                        .orElse(null);

        System.out.println(score);
    }

    @Test
    public void testEnum(){
        System.out.println(PolicyStatus.Draft.getValue());
    }
}
