package com.jpsoft.picc.modules.auth.controller;

import com.github.pagehelper.Page;
import com.jpsoft.picc.modules.base.entity.InsuranceDefinition;
import com.jpsoft.picc.modules.base.entity.Jobs;
import com.jpsoft.picc.modules.base.service.JobsService;
import com.jpsoft.picc.modules.common.dto.MessageResult;
import com.jpsoft.picc.modules.common.dto.Sort;
import com.jpsoft.picc.modules.common.utils.PojoUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Api(description="职业管理")
@RestController
@RequestMapping("/auth/jobs")
@Slf4j
public class JobsController {
    @Autowired
    private JobsService jobsService;

    @ApiOperation(value="所有岗位列表")
    @RequestMapping(value = "list",method = RequestMethod.POST)
    public MessageResult<List<Jobs>> list(){
        MessageResult<List<Jobs>> msgResult = new MessageResult<>();

        List<Jobs> list = jobsService.list();

        msgResult.setResult(true);
        msgResult.setData(list);

        return msgResult;
    }
}
